> ## Documentation Index
> Fetch the complete documentation index at: https://docs.toku.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Bulk Upload Custody Wallets

> Bulk-creates custody wallets from uploaded rows; Anchorage rows are matched against live Anchorage vault wallets first.

Not available to API keys yet. It will need `wallets:write`.

## OpenAPI

````yaml api-reference/openapi.json POST /tga/bulk-upload-custody-wallets
openapi: 3.1.0
info:
  title: Toku API
  version: 1.0.0
servers:
  - url: https://api.toku.com
security:
  - bearerAuth: []
paths:
  /tga/bulk-upload-custody-wallets:
    post:
      operationId: bulkUploadCustodyWallets
      summary: Bulk Upload Custody Wallets
      description: >-
        Bulk-creates custody wallets from uploaded rows; Anchorage rows are
        matched against live Anchorage vault wallets first.


        Not available to API keys yet. It will need `wallets:write`.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BulkUploadCustodyWalletsRequest'
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BulkUploadCustodyWalletsResponse'
        '400':
          description: Bad request
        '401':
          description: Unauthorized
        '403':
          description: Forbidden
        '404':
          description: Not found
        '409':
          description: Conflict
        '429':
          description: Response 429
components:
  schemas:
    BulkUploadCustodyWalletsRequest:
      type: object
      properties:
        wallets:
          type: array
          items:
            type: object
            properties:
              walletAddress:
                type: string
                minLength: 1
              network:
                type: string
                enum:
                  - ETHEREUM
                  - ETHEREUM_SEPOLIA
                  - SOLANA
                  - POLYGON
                  - ZKSYNC
                  - BASE
                  - OPTIMISM
                  - SCROLL
                  - BNB_SMART_CHAIN
                  - SHAPE
                  - KATANA
                  - RITUAL
                  - KAVA
                  - OSMOSIS
                  - FILECOIN
              custodyProvider:
                type: string
                enum:
                  - SAFE
                  - SAFE_PROPOSER
                  - ANCHORAGE
                  - FIREBLOCKS
                  - SQUADS
                  - COINBASE
                  - FILECOIN_SELF_CUSTODY
                  - FORDEFI
                  - BITGO
              walletName:
                type: string
              anchorageVaultId:
                type: string
            required:
              - walletAddress
              - network
              - custodyProvider
          minItems: 1
      required:
        - wallets
    BulkUploadCustodyWalletsResponse:
      type: object
      properties:
        success:
          type: boolean
        message:
          type: string
      required:
        - success
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
````
